/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * -COPYING-
 * The Practice of Programming - by Brian W. Kernighan & Rob Pike
 */
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "wlist.h"

/* newitem: offset word  ο ׸ 
 */
extern WList
*newitem(int num, long offset, char *word)
{
	WList *newp;

	newp = (WList *)malloc(sizeof(WList));

	newp->num = num;
	newp->offset = offset;
	newp->word = strdup(word);
	newp->next = NULL;

	return newp;
}

/* addfront: newp listp  տ 
 */
extern WList
*addfront(WList *listp, WList *newp)
{
	newp->next = listp;
	return newp;
}

/* freeall: listp ִ  Ҹ 
 */
extern void
freeall(WList *listp)
{
	WList *next;

	for ( ; listp != NULL; listp = next) {
		next = listp->next;
		free(listp->word);
		free(listp);
	}
}

/* ListSearchWord: Ʈ ܾ ˻
 */
extern WList
*ListSearchWord(WList *listp, char *word)
{
	for ( ; listp != NULL; listp = listp->next) {
		if (strcmp(word, listp->word) == '\0') {
			return listp;
		}
	}

	return NULL; /* ã  */
}
