/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>

/* tagRemove: orig ˻ tag ġȯڸ  Ǵ ȯ
 */
extern char
*tagRemove(const char *orig)
{
	int o_pos = 0;
	static char s[100000];

	int boolTag = 0;
	int t_pos = 0;
	char tag[BUFSIZ+1];

	int s_pos = 0;

	char *searchList[] = {
		"br", "lt", "gt", "nbsp", NULL
	};

	char changeList[] = {
		'\n', '<', '>', ' ', '\0'
	};

	while (orig[o_pos] != '\0') {
		if (orig[o_pos] == '<'
		||  (orig[o_pos] == '&' && orig[o_pos+1] != '[')) {
			boolTag = 1;
			o_pos++;
			continue;
		} else if ((orig[o_pos] == '>'
			|| orig[o_pos] == ';') && boolTag == 1) {
			int i;
			
			tag[t_pos] = '\0';

			for (i = 0; searchList[i] != NULL; i++) {
				if (strcmp(tag, searchList[i]) == '\0') {
					s[s_pos] = changeList[i];
					s_pos++;
				}
			}
			
			t_pos = 0;
			boolTag = 0;
			o_pos++;
			continue;
		}
		
		if (boolTag == 0) {
			s[s_pos] = orig[o_pos];
			s_pos++;
		} else {
			tag[t_pos] = orig[o_pos];
			t_pos++;
		}
	
		o_pos++;
	}
	s[s_pos] = '\0';

	return s; /* tag  ȯ (ڿ) */
}

/* tagList: orig ˻ start ϴ tag ã  ȯ
 */
extern char
**tagList(const char *orig, const char *start)
{
	int o_pos = 0;

	int boolTag = 0;
	int t_pos = 0;
	char tag[BUFSIZ+1];
	
	int l_pos = 0;
	static char *list[BUFSIZ+1];

	list[0] = '\0';
	while (orig[o_pos] != '\0') {
		if (orig[o_pos] == '<'
		||  (orig[o_pos] == '&' && orig[o_pos+1] != '[')) {
			boolTag = 1;
			o_pos++;
			continue;
		} else if (orig[o_pos] == '>'
			|| orig[o_pos] == ';') {
			
			tag[t_pos] = '\0';
			if (strncmp(tag, start, strlen(start)) == '\0') {
				list[l_pos] = strdup(tag);
				l_pos++;
			} else {
			}
			
			t_pos = 0;
			boolTag = 0;
			o_pos++;
			continue;
		}
		
		if (boolTag == 1) {
			tag[t_pos] = orig[o_pos];
			t_pos++;
		}
	
		o_pos++;
	}
	list[l_pos] = NULL;

	return list; /* tag  ȯ () */
}
